#!/bin/bash

# to use this shellscript put it in your home directory (root's), get into the
# dir with all RRDs, then do this:
#
# find . -name '*free_pages*' | perl -ne 'if (/\.\/(.+?)\.rrd/) { print "$1\n"; }' | awk '{print ". ~/makeMin1RrdIntoMin0Rrd.sh "$1}'
#
# either copy/paste the output into the shell, or append a " | sh" at the end
# to actually execute what you see
#
# Call this script without the extension.

rrdToWorkWith=$1

# dump out the rrd...
rrdtool dump $rrdToWorkWith.rrd > $rrdToWorkWith.xml
if [ $? ] ; then echo "quitting due to error." ; exit 255 ; fi

# change all NaN into 0
# let there be a minimum value of 0
cat $rrdToWorkWith.xml | sed -e 's-<v> NaN </v>-<v> 0.0000000000e+00 </v>-g' \
 | sed -e 's-<min> 1.0000000000e+00 </min>-<min> 0.0000000000e+00 </min>-g' > tmp
if [ $? ] ; then echo "quitting due to error." ; exit 255 ; fi
mv tmp $rrdToWorkWith.xml 
if [ $? ] ; then echo "quitting due to error." ; exit 255 ; fi

chown --reference=$rrdToWorkWith.rrd $rrdToWorkWith.xml
if [ $? ] ; then echo "quitting due to error." ; exit 255 ; fi

# get rid of the rrd in preparation for recreating it from the XML
rm -f $rrdToWorkWith.rrd ; rrdtool restore $rrdToWorkWith.xml $rrdToWorkWith.rrd
if [ $? ] ; then echo "failed to restore XML-->RRD, fix now lest ye lose datapoints." ; exit 255 ; fi

